org.codehaus.plexus

## Interface PlexusContainer

All Known Implementing Classes:
  DefaultPlexusContainer

    public interface PlexusContainer

### Field Summary

Fields
`static String` `ROLE`

### Method Summary

Methods
`void` `addComponentDescriptor(ComponentDescriptor componentDescriptor)`
`void` `addContextValue(Object key, Object value)`
`void` `addJarRepository(File repository)`
`void` `addJarResource(File resource)`
`void` `composeComponent(Object component, ComponentDescriptor componentDescriptor)`
`PlexusContainer` `createChildContainer(String name, List classpathJars, Map context)`
`PlexusContainer` `createChildContainer(String name, List classpathJars, Map context, List discoveryListeners)`
`Object` `createComponentInstance(ComponentDescriptor componentDescriptor)`
`void` `dispose()`
`PlexusContainer` `getChildContainer(String name)`
`ComponentDescriptor` `getComponentDescriptor(String componentKey)`
`List` `getComponentDescriptorList(String role)`
`Map` `getComponentDescriptorMap(String role)`
`ClassRealm` `getComponentRealm(String componentKey)` Deprecated. Use getContainerRealm() instead.
`ClassRealm` `getContainerRealm()`
`Context` `getContext()`
`Date` `getCreationDate()`
`Logger` `getLogger()`
`LoggerManager` `getLoggerManager()`
`boolean` `hasChildContainer(String name)`
`boolean` `hasComponent(String componentKey)`
`boolean` `hasComponent(String role, String roleHint)`
`void` `initialize()`
`boolean` `isInitialized()`
`boolean` `isStarted()`
`Object` `lookup(String componentKey)`
`Object` `lookup(String role, String roleHint)`
`List` `lookupList(String role)`
`Map` `lookupMap(String role)`
`void` `registerComponentDiscoveryListener(ComponentDiscoveryListener listener)`
`void` `release(Object component)`
`void` `releaseAll(List components)`
`void` `releaseAll(Map components)`
`void` `removeChildContainer(String name)`
`void` `removeComponentDiscoveryListener(ComponentDiscoveryListener listener)`
`void` `resume(Object component)`
`void` `setConfigurationResource(Reader configuration)`
`void` `setLoggerManager(LoggerManager loggerManager)`
`void` `setParentPlexusContainer(PlexusContainer parentContainer)`
`void` `start()`
`void` `suspend(Object component)`

### Field Detail

#### ROLE

    static final String ROLE

### Method Detail

#### getCreationDate

    Date getCreationDate()

#### hasChildContainer

    boolean hasChildContainer(String name)

#### removeChildContainer

    void removeChildContainer(String name)

#### getChildContainer

    PlexusContainer getChildContainer(String name)

#### createChildContainer

    PlexusContainer createChildContainer(String name,
                                       List classpathJars,
                                       Map context)
                                         throws PlexusContainerException

Throws:
  `PlexusContainerException`

#### createChildContainer

    PlexusContainer createChildContainer(String name,
                                       List classpathJars,
                                       Map context,
                                       List discoveryListeners)
                                         throws PlexusContainerException

Throws:
  `PlexusContainerException`

#### lookup

    Object lookup(String componentKey)
                  throws ComponentLookupException

Throws:
  `ComponentLookupException`

#### lookup

    Object lookup(String role,
                String roleHint)
                  throws ComponentLookupException

Throws:
  `ComponentLookupException`

#### lookupMap

    Map lookupMap(String role)
                  throws ComponentLookupException

Throws:
  `ComponentLookupException`

#### lookupList

    List lookupList(String role)
                    throws ComponentLookupException

Throws:
  `ComponentLookupException`

#### getComponentDescriptor

    ComponentDescriptor getComponentDescriptor(String componentKey)

#### getComponentDescriptorMap

    Map getComponentDescriptorMap(String role)

#### getComponentDescriptorList

    List getComponentDescriptorList(String role)

#### addComponentDescriptor

    void addComponentDescriptor(ComponentDescriptor componentDescriptor)
                                throws ComponentRepositoryException

Throws:
  `ComponentRepositoryException`

#### release

    void release(Object component)
                 throws ComponentLifecycleException

Throws:
  `ComponentLifecycleException`

#### releaseAll

    void releaseAll(Map components)
                    throws ComponentLifecycleException

Throws:
  `ComponentLifecycleException`

#### releaseAll

    void releaseAll(List components)
                    throws ComponentLifecycleException

Throws:
  `ComponentLifecycleException`

#### hasComponent

    boolean hasComponent(String componentKey)

#### hasComponent

    boolean hasComponent(String role,
                       String roleHint)

#### suspend

    void suspend(Object component)
                 throws ComponentLifecycleException

Throws:
  `ComponentLifecycleException`

#### resume

    void resume(Object component)
                throws ComponentLifecycleException

Throws:
  `ComponentLifecycleException`

#### initialize

    void initialize()
                    throws PlexusContainerException

Throws:
  `PlexusContainerException`

#### isInitialized

    boolean isInitialized()

#### start

    void start()
               throws PlexusContainerException

Throws:
  `PlexusContainerException`

#### isStarted

    boolean isStarted()

#### dispose

    void dispose()

#### getContext

    Context getContext()

#### setParentPlexusContainer

    void setParentPlexusContainer(PlexusContainer parentContainer)

#### addContextValue

    void addContextValue(Object key,
                       Object value)

#### setConfigurationResource

    void setConfigurationResource(Reader configuration)
                                  throws PlexusConfigurationResourceException

Throws:
  `PlexusConfigurationResourceException`

#### getLogger

    Logger getLogger()

#### createComponentInstance

    Object createComponentInstance(ComponentDescriptor componentDescriptor)
                                   throws ComponentInstantiationException,
                                          ComponentLifecycleException

Throws:
  `ComponentInstantiationException`
  `ComponentLifecycleException`

#### composeComponent

    void composeComponent(Object component,
                        ComponentDescriptor componentDescriptor)
                          throws CompositionException,
                                 UndefinedComponentComposerException

Throws:
  `CompositionException`
  `UndefinedComponentComposerException`

#### registerComponentDiscoveryListener

    void registerComponentDiscoveryListener(ComponentDiscoveryListener listener)

#### removeComponentDiscoveryListener

    void removeComponentDiscoveryListener(ComponentDiscoveryListener listener)

#### addJarRepository

    void addJarRepository(File repository)

#### addJarResource

    void addJarResource(File resource)
                        throws PlexusContainerException

Throws:
  `PlexusContainerException`

#### getContainerRealm

    ClassRealm getContainerRealm()

#### getComponentRealm

    ClassRealm getComponentRealm(String componentKey)

Deprecated. Use getContainerRealm() instead.

#### setLoggerManager

    void setLoggerManager(LoggerManager loggerManager)

#### getLoggerManager

    LoggerManager getLoggerManager()